org.modeshape.jdbc

## Class JcrConnection

- java.lang.Object
- - org.modeshape.jdbc.JcrConnection

- All Implemented Interfaces:
    AutoCloseable, Connection, Wrapper

      public class JcrConnection
      extends Object
      implements Connection

  This driver's implementation of JDBC `Connection`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `JCR_SQL`
    `static String` | `JCR_SQL2`

    - ### Fields inherited from interface java.sql.Connection

      `TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JcrConnection(RepositoryDelegate jcrDelegate, DriverInfo driverInfo)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `abort(Executor executor)` Terminates an open connection.
    `void` | `clearWarnings()`
    `void` | `close()`
    `void` | `commit()`
    `Array` | `createArrayOf(String typeName, Object[] elements)`
    `Blob` | `createBlob()`
    `Clob` | `createClob()`
    `NClob` | `createNClob()`
    `SQLXML` | `createSQLXML()`
    `Statement` | `createStatement()`
    `Statement` | `createStatement(int resultSetType, int resultSetConcurrency)`
    `Statement` | `createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
    `Struct` | `createStruct(String typeName, Object[] attributes)`
    `protected DriverInfo` | `driverInfo()`
    `boolean` | `getAutoCommit()`
    `String` | `getCatalog()`
    `Properties` | `getClientInfo()`
    `String` | `getClientInfo(String name)`
    `int` | `getHoldability()`
    `DatabaseMetaData` | `getMetaData()`
    `int` | `getNetworkTimeout()` This method is not implemented and always throws `SQLFeatureNotSupportedException`.
    `RepositoryDelegate` | `getRepositoryDelegate()` Returns the interface used to communicate to the Jcr Repository.
    `String` | `getSchema()` Retrieves this Connection object's current schema name.
    `int` | `getTransactionIsolation()`
    `Map<String,Class<?>>` | `getTypeMap()`
    `SQLWarning` | `getWarnings()`
    `protected ConnectionInfo` | `info()`
    `boolean` | `isClosed()`
    `boolean` | `isReadOnly()`
    `boolean` | `isValid(int timeout)`
    `boolean` | `isWrapperFor(Class<?> iface)`
    `String` | `nativeSQL(String sql)` This method pre-processes the supplied SQL-compatible query and returns the corresponding JCR-SQL2.
    `protected NodeType` | `nodeType(String name)`
    `protected void` | `notClosed()`
    `CallableStatement` | `prepareCall(String sql)`
    `CallableStatement` | `prepareCall(String sql, int resultSetType, int resultSetConcurrency)`
    `CallableStatement` | `prepareCall(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
    `PreparedStatement` | `prepareStatement(String sql)`
    `PreparedStatement` | `prepareStatement(String sql, int autoGeneratedKeys)`
    `PreparedStatement` | `prepareStatement(String sql, int[] columnIndexes)`
    `PreparedStatement` | `prepareStatement(String sql, int resultSetType, int resultSetConcurrency)`
    `PreparedStatement` | `prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)`
    `PreparedStatement` | `prepareStatement(String sql, String[] columnNames)`
    `void` | `releaseSavepoint(Savepoint savepoint)`
    `void` | `rollback()`
    `void` | `rollback(Savepoint savepoint)`
    `void` | `setAutoCommit(boolean autoCommit)`
    `void` | `setCatalog(String catalog)`
    `void` | `setClientInfo(Properties properties)`
    `void` | `setClientInfo(String name, String value)`
    `void` | `setHoldability(int holdability)`
    `void` | `setNetworkTimeout(Executor executor, int milliseconds)` This method is not implemented and always throws `SQLFeatureNotSupportedException`.
    `void` | `setReadOnly(boolean readOnly)`
    `Savepoint` | `setSavepoint()`
    `Savepoint` | `setSavepoint(String name)`
    `void` | `setSchema(String schema)` Sets the given schema name to access.
    `void` | `setTransactionIsolation(int level)`
    `void` | `setTypeMap(Map<String,Class<?>> map)`
    `<T> T` | `unwrap(Class<T> iface)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### JCR_SQL2

          public static final String JCR_SQL2

      See Also:
        Constant Field Values

    - #### JCR_SQL

          public static final String JCR_SQL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JcrConnection

          public JcrConnection(RepositoryDelegate jcrDelegate,
                       DriverInfo driverInfo)

  - ### Method Detail

    - #### info

          protected ConnectionInfo info()

    - #### driverInfo

          protected DriverInfo driverInfo()

    - #### getRepositoryDelegate

          public RepositoryDelegate getRepositoryDelegate()

      Returns the interface used to communicate to the Jcr Repository.
      Returns:
        RepositoryDelegate

    - #### nodeType

          protected NodeType nodeType(String name)
                               throws SQLException

      Throws:
        `SQLException`

    - #### isReadOnly

          public boolean isReadOnly()
                             throws SQLException

      Specified by:
        `isReadOnly` in interface `Connection`
      Throws:
        `SQLException`

    - #### setReadOnly

          public void setReadOnly(boolean readOnly)
                           throws SQLException

      Specified by:
        `setReadOnly` in interface `Connection`
      Throws:
        `SQLException`

    - #### isValid

          public boolean isValid(int timeout)
                          throws SQLException

      Specified by:
        `isValid` in interface `Connection`
      Throws:
        `SQLException`

    - #### close

          public void close()

      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Connection`

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in interface `Connection`

    - #### notClosed

          protected final void notClosed()
                                  throws SQLException

      Throws:
        `SQLException`

    - #### commit

          public void commit()
                      throws SQLException

      Specified by:
        `commit` in interface `Connection`
      Throws:
        `SQLException`

    - #### rollback

          public void rollback()
                        throws SQLException

      Specified by:
        `rollback` in interface `Connection`
      Throws:
        `SQLException`

    - #### rollback

          public void rollback(Savepoint savepoint)
                        throws SQLException

      Specified by:
        `rollback` in interface `Connection`
      Throws:
        `SQLException`

    - #### clearWarnings

          public void clearWarnings()
                             throws SQLException

      Specified by:
        `clearWarnings` in interface `Connection`
      Throws:
        `SQLException`

    - #### getWarnings

          public SQLWarning getWarnings()
                                 throws SQLException

      Specified by:
        `getWarnings` in interface `Connection`
      Throws:
        `SQLException`

    - #### getAutoCommit

          public boolean getAutoCommit()
                                throws SQLException

      Specified by:
        `getAutoCommit` in interface `Connection`
      Throws:
        `SQLException`

    - #### setAutoCommit

          public void setAutoCommit(boolean autoCommit)
                             throws SQLException

      Specified by:
        `setAutoCommit` in interface `Connection`
      Throws:
        `SQLException`

    - #### getTransactionIsolation

          public int getTransactionIsolation()
                                      throws SQLException

      Specified by:
        `getTransactionIsolation` in interface `Connection`
      Throws:
        `SQLException`

    - #### setTransactionIsolation

          public void setTransactionIsolation(int level)
                                       throws SQLException

      Specified by:
        `setTransactionIsolation` in interface `Connection`
      Throws:
        `SQLException`

    - #### setSavepoint

          public Savepoint setSavepoint()
                                 throws SQLException

      Specified by:
        `setSavepoint` in interface `Connection`
      Throws:
        `SQLException`

    - #### setSavepoint

          public Savepoint setSavepoint(String name)
                                 throws SQLException

      Specified by:
        `setSavepoint` in interface `Connection`
      Throws:
        `SQLException`

    - #### releaseSavepoint

          public void releaseSavepoint(Savepoint savepoint)
                                throws SQLException

      Specified by:
        `releaseSavepoint` in interface `Connection`
      Throws:
        `SQLException`

    - #### getCatalog

          public String getCatalog()

      Specified by:
        `getCatalog` in interface `Connection`

    - #### setCatalog

          public void setCatalog(String catalog)

      Specified by:
        `setCatalog` in interface `Connection`

    - #### getClientInfo

          public Properties getClientInfo()

      Specified by:
        `getClientInfo` in interface `Connection`

    - #### getClientInfo

          public String getClientInfo(String name)

      Specified by:
        `getClientInfo` in interface `Connection`

    - #### setClientInfo

          public void setClientInfo(Properties properties)
                             throws SQLClientInfoException

      Specified by:
        `setClientInfo` in interface `Connection`
      Throws:
        `SQLClientInfoException`

    - #### setClientInfo

          public void setClientInfo(String name,
                           String value)
                             throws SQLClientInfoException

      Specified by:
        `setClientInfo` in interface `Connection`
      Throws:
        `SQLClientInfoException`

    - #### getHoldability

          public int getHoldability()
                             throws SQLException

      Specified by:
        `getHoldability` in interface `Connection`
      Throws:
        `SQLException`

    - #### setHoldability

          public void setHoldability(int holdability)
                              throws SQLException

      Specified by:
        `setHoldability` in interface `Connection`
      Throws:
        `SQLException`

    - #### getMetaData

          public DatabaseMetaData getMetaData()
                                       throws SQLException

      Specified by:
        `getMetaData` in interface `Connection`
      Throws:
        `SQLException`

    - #### getTypeMap

          public Map<String,Class<?>> getTypeMap()

      Specified by:
        `getTypeMap` in interface `Connection`

    - #### setTypeMap

          public void setTypeMap(Map<String,Class<?>> map)
                          throws SQLException

      Specified by:
        `setTypeMap` in interface `Connection`
      Throws:
        `SQLException`

    - #### nativeSQL

          public String nativeSQL(String sql)

      This method pre-processes the supplied SQL-compatible query and returns the corresponding JCR-SQL2.

      Specified by:
        `nativeSQL` in interface `Connection`
      See Also:
        `Connection.nativeSQL(java.lang.String)`

    - #### createStatement

          public Statement createStatement()
                                    throws SQLException

      Specified by:
        `createStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### createStatement

          public Statement createStatement(int resultSetType,
                                  int resultSetConcurrency)
                                    throws SQLException

      Specified by:
        `createStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### createStatement

          public Statement createStatement(int resultSetType,
                                  int resultSetConcurrency,
                                  int resultSetHoldability)
                                    throws SQLException

      Specified by:
        `createStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql,
                                           int autoGeneratedKeys)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql,
                                           int[] columnIndexes)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql,
                                           String[] columnNames)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql,
                                           int resultSetType,
                                           int resultSetConcurrency)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareStatement

          public PreparedStatement prepareStatement(String sql,
                                           int resultSetType,
                                           int resultSetConcurrency,
                                           int resultSetHoldability)
                                             throws SQLException

      Specified by:
        `prepareStatement` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareCall

          public CallableStatement prepareCall(String sql)
                                        throws SQLException

      Specified by:
        `prepareCall` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareCall

          public CallableStatement prepareCall(String sql,
                                      int resultSetType,
                                      int resultSetConcurrency)
                                        throws SQLException

      Specified by:
        `prepareCall` in interface `Connection`
      Throws:
        `SQLException`

    - #### prepareCall

          public CallableStatement prepareCall(String sql,
                                      int resultSetType,
                                      int resultSetConcurrency,
                                      int resultSetHoldability)
                                        throws SQLException

      Specified by:
        `prepareCall` in interface `Connection`
      Throws:
        `SQLException`

    - #### createArrayOf

          public Array createArrayOf(String typeName,
                            Object[] elements)
                              throws SQLException

      Specified by:
        `createArrayOf` in interface `Connection`
      Throws:
        `SQLException`

    - #### createBlob

          public Blob createBlob()
                          throws SQLException

      Specified by:
        `createBlob` in interface `Connection`
      Throws:
        `SQLException`

    - #### createClob

          public Clob createClob()
                          throws SQLException

      Specified by:
        `createClob` in interface `Connection`
      Throws:
        `SQLException`

    - #### createNClob

          public NClob createNClob()
                            throws SQLException

      Specified by:
        `createNClob` in interface `Connection`
      Throws:
        `SQLException`

    - #### createSQLXML

          public SQLXML createSQLXML()
                              throws SQLException

      Specified by:
        `createSQLXML` in interface `Connection`
      Throws:
        `SQLException`

    - #### createStruct

          public Struct createStruct(String typeName,
                            Object[] attributes)
                              throws SQLException

      Specified by:
        `createStruct` in interface `Connection`
      Throws:
        `SQLException`

    - #### isWrapperFor

          public boolean isWrapperFor(Class<?> iface)

      Specified by:
        `isWrapperFor` in interface `Wrapper`

    - #### unwrap

          public <T> T unwrap(Class<T> iface)
                   throws SQLException

      Specified by:
        `unwrap` in interface `Wrapper`
      Throws:
        `SQLException`

    - #### setSchema

          public void setSchema(String schema)
                         throws SQLException

      Sets the given schema name to access. If the driver does not support schemas, it will silently ignore this request. Calling setSchema has no effect on previously created or prepared Statement objects. It is implementation defined whether a DBMS prepare operation takes place immediately when the Connection method prepareStatement or prepareCall is invoked. For maximum portability, setSchema should be called before a Statement is created or prepared.
      Specified by:
        `setSchema` in interface `Connection`
      Parameters:
        `schema` - - the name of a schema in which to work
      Throws:
        `SQLException` - - if a database access error occurs or this method is called on a closed connection

    - #### getSchema

          public String getSchema()
                           throws SQLException

      Retrieves this Connection object's current schema name.
      Specified by:
        `getSchema` in interface `Connection`
      Returns:
        the current schema name or null if there is none
      Throws:
        `SQLException` - - if a database access error occurs or this method is called on a closed connection

    - #### abort

          public void abort(Executor executor)

      Terminates an open connection.

      Note: This method is part of the JDBC API in JDK 1.7.

      Specified by:
        `abort` in interface `Connection`
      Parameters:
        `executor` - The `Executor` implementation which will be used by `abort`.

    - #### setNetworkTimeout

          public void setNetworkTimeout(Executor executor,
                               int milliseconds)
                                 throws SQLException

      This method is not implemented and always throws `SQLFeatureNotSupportedException`.

      Note: This method is part of the JDBC API in JDK 1.7.

      Specified by:
        `setNetworkTimeout` in interface `Connection`
      Parameters:
        `executor` - The `Executor` implementation which will be used by `setNetworkTimeout`.
        `milliseconds` - The time in milliseconds to wait for the database operation to complete. If the JDBC driver does not support milliseconds, the JDBC driver will round the value up to the nearest second. If the timeout period expires before the operation completes, a SQLException will be thrown. A value of 0 indicates that there is not timeout for database operations.
      Throws:
        `SQLException`
        `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

    - #### getNetworkTimeout

          public int getNetworkTimeout()
                                throws SQLException

      This method is not implemented and always throws `SQLFeatureNotSupportedException`.

      Note: This method is part of the JDBC API in JDK 1.7.

      Specified by:
        `getNetworkTimeout` in interface `Connection`
      Returns:
        the timeout
      Throws:
        `SQLException`
        `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.